package com.zd.exam.service;

import com.zd.exam.domain.ElPaper;
import com.zd.exam.domain.vo.ElPaperAssessVo;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * 试卷管理Service接口
 *
 * @author zd
 * @date 2021-08-31
 */
public interface IElPaperService {
    /**
     * 查询试卷管理
     *
     * @param id 试卷管理主键
     * @return 试卷管理
     */
    public ElPaper selectElPaperById(Long id);

    /**
     * 查询试卷管理列表
     *
     * @param elPaper 试卷管理
     * @return 试卷管理集合
     */
    public List<ElPaper> selectElPaperList(ElPaper elPaper);

    /**
     * 新增试卷管理
     *
     * @param elPaper 试卷管理
     * @return 结果
     */
//    public int insertElPaper(ElPaper elPaper);

    /**
     * 修改试卷管理
     *
     * @param elPaper 试卷管理
     * @return 结果
     */
    public int updateElPaper(ElPaper elPaper);

    /**
     * 批量删除试卷管理
     *
     * @param ids 需要删除的试卷管理主键集合
     * @return 结果
     */
    public int deleteElPaperByIds(Long[] ids);

    /**
     * 删除试卷管理信息
     *
     * @param id 试卷管理主键
     * @return 结果
     */
    public int deleteElPaperById(Long id);

    Long createPaper(Long examId);

    Map<String, Object> handPaper(ElPaper elPaper, HttpServletRequest request);

    ElPaper paperResult(ElPaper elPaper);

    Map<String, Object> getPaperStatistics(Long id);

    /**
     * 超时弃考
     */
    void abandonPaper();

    ElPaper startAssess(Long courseChapterId);

    Map<String, Object> finishAssess(Long paperId);

    ElPaper assessDetail(Long paperId);

    List<ElPaperAssessVo> assessList(Long courseChapterId);

    List<ElPaperAssessVo> allAssessList(Long courseChapterId);
}
